<template>
  <div class="flight-planner">
    <v-navigation-drawer app width="300">
      <v-list-item>
        <v-list-item-content>
          <v-list-item-title class="title"> Flight Planner </v-list-item-title>
          <v-list-item-subtitle> Edit flight routes </v-list-item-subtitle>
          <v-list-item-subtitle> Create flight schedules </v-list-item-subtitle>
        </v-list-item-content>
      </v-list-item>

      <v-divider></v-divider>
      <div id="buttonsDiv">
        <ul>
        <li><v-btn depressed :height="20" @click="loadRouteList">Route list</v-btn></li>
        <li><v-btn depressed :height="20" @click="newRoute">New route</v-btn></li>
        </ul>
      </div>
      <v-divider></v-divider>

      <currently-edited-flight-path-app-bar
        v-if="route_editing"
        :currently_edited_flight_path="currently_edited_flight_path"
        :focused_segment_index="focused_route_segment_index"
        @focus-updated="updateSelectedSegment"
        @save-route="saveRoute"
        @modify-route="modifyRoute"
        @delete-route="deleteRoute"
        @remove-segment="removeSegment"
      />

      <route-list-app-bar
      v-else
      :route_data_list="route_list"
      :show_current="route_loaded"
      @route-clicked="loadRouteAtIndex"
      @return-to-current-route="returnToCurrentRoute" />
    </v-navigation-drawer>

    <div id="flightPlannerMapDiv">Map will appear here soon</div>
    <v-row> </v-row>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import axios from "axios";
import L from "leaflet";
import "leaflet/dist/leaflet.css";

import API_URL from "@/api/api_url";
import CurrentlyEditedFlightPathAppBar from "@/components/FlightPlanner/CurrentlyEditedFlightPathAppBar.vue";
import RouteListAppBar from "@/components/RouteListAppBar.vue";
import FlightRoute, { FlightRouteSegment } from "@/components/FlightRoute";
import common_map_constructor from '@/components/CommonMapConstructor';
import { RouteNode } from "@/components/MapMarkers";
import RouteData, {
  loadRoutesFromServer, saveRouteOnServer, modifyRouteOnServer, deleteRouteOnServer
  } from "@/components/RoutesManagement";

@Component({
  components: { CurrentlyEditedFlightPathAppBar, RouteListAppBar },
})
export default class FlightPlanner extends Vue {
  map!: L.Map;

  currently_edited_flight_path = new FlightRoute();

  focused_route_segment_index = -1;

  node_positions = [] as L.LatLng[];

  markers = [] as L.Marker[];

  lines = new L.Polyline([]);

  focused_line = new L.Polyline([], { color: "yellow", weight: 5 });

  last_time_when_marker_dragged = 0;

  route_list = [] as RouteData[];

  loaded_route_data_index = -1;

  route_loaded = false;

  route_editing = false;

  created() {
    console.log("Flight planner Created");
  }

  mounted() {
    console.log("Flight planner mounted");
    this.setupLeaflet();
    this.loadRouteList();
    console.log("API_URL is", API_URL);
  }

  setupLeaflet() {
    console.log("Setting up leaflet");
    this.map = common_map_constructor("flightPlannerMapDiv");

    this.lines.addTo(this.map);
    this.focused_line.addTo(this.map);
    this.map.on("click", this.onclick);
  }

  onclick(e: L.LeafletMouseEvent) {
    if (this.isClickPossible()) {
      if (!this.route_loaded) {
        this.newRoute();
        this.route_loaded = true;
        this.route_editing = true;
      }

      this.currently_edited_flight_path.segments.push(
        new FlightRouteSegment(50, e.latlng, 10, true, e.latlng)
      );
      this.node_positions.push(e.latlng);
      this.addMarker(e.latlng);
      this.updateMap();

      this.focused_route_segment_index = this.markers.length - 1;
      this.updateSelectedSegment(this.focused_route_segment_index);
    }
  }

  addMarker(latLng: L.LatLng) {
    const marker = new RouteNode(latLng);
    marker.on("dragstart", () => {
      this.focused_route_segment_index = this.markers.indexOf(marker);
      marker.setOpacity(0.25);
      this.updateMap();
    });
    // @ts-ignore
    marker.on("drag", (event: L.LeafletMouseEvent) => {
      const index = this.markers.indexOf(marker);
      this.currently_edited_flight_path.segments[index].end_position = event.latlng;
      this.node_positions[index] = event.latlng;
      this.updateMap();
    });
    marker.on("dragend", () => {
      this.last_time_when_marker_dragged = new Date().getTime();
      marker.setOpacity(1);
    });

    marker.on("click", () => {
      this.focused_route_segment_index = this.markers.indexOf(marker);
      this.updateMap();
    });
    marker.on("dblclick", () => {
      if (this.isClickPossible()) {
        const index = this.markers.indexOf(marker);
        this.removeSegment(index);
      }
    });
    this.markers.push(marker);
    marker.addTo(this.map);

    if (this.markers.indexOf(marker) === 0) {
      this.updateStartNodeMarker();
    }
  }

  isClickPossible() {
    return new Date().getTime() - this.last_time_when_marker_dragged > 300;
  }

  removeSegment(index: number) {
    this.currently_edited_flight_path.segments.splice(index, 1);
    this.node_positions.splice(index, 1);
    this.map.removeLayer(this.markers[index]);
    this.markers.splice(index, 1);
    this.focused_route_segment_index = -1;

    this.updateMap();
    this.updateStartNodeMarker();
  }

  updateStartNodeMarker() {
    if (this.markers.length >= 1) {
      this.markers[0].setIcon(RouteNode.route_start_node_icon);
    }
  }

  updateMap() {
    this.lines.setLatLngs(this.node_positions);
    this.updateSelectedSegment(this.focused_route_segment_index);
  }

  updateSelectedSegment(index: number) {
    this.focused_route_segment_index = index;

    if (index > 0) {
      this.focused_line.setLatLngs([
        this.node_positions[index - 1],
        this.node_positions[index],
      ]);
    } else {
      this.focused_line.setLatLngs([]);
    }
  }

  clearRouteOnMap() {
    this.currently_edited_flight_path.segments.splice(
      0,
      this.currently_edited_flight_path.segments.length
    );
    this.currently_edited_flight_path.name = "New route";
    this.lines.setLatLngs([]);
    this.focused_line.setLatLngs([]);
    this.node_positions = [];

    for (const marker of this.markers) {
      this.map.removeLayer(marker);
    }
    this.markers.splice(0, this.markers.length);

    this.focused_route_segment_index = -1;
  }

  returnToCurrentRoute() {
    this.route_editing = true;
  }

  newRoute() {
    this.clearRouteOnMap();
    this.route_editing = true;
  }

  async loadRouteList() {
    this.route_list = await loadRoutesFromServer();
    this.route_editing = false;
  }

  loadRouteAtIndex(index: number) {
    this.route_editing = true;
    this.loaded_route_data_index = index;
    this.loadRouteToMap(this.route_list[this.loaded_route_data_index].route);
    this.map.setView(this.currently_edited_flight_path.segments[0].end_position, 16);
  }

  loadRouteToMap(route: FlightRoute) {
    this.clearRouteOnMap();
    this.currently_edited_flight_path = route;
    this.makeMapElements();
  }

  makeMapElements() {
    for (const segment of this.currently_edited_flight_path.segments) {
      this.node_positions.push(segment.end_position);
      this.addMarker(segment.end_position);
    }
    this.focused_route_segment_index = -1;
    this.updateMap();
  }

  saveRoute() {
    saveRouteOnServer(this.currently_edited_flight_path);
  }

  modifyRoute() {
    modifyRouteOnServer(this.currently_edited_flight_path,
    this.route_list[this.loaded_route_data_index].id);
  }

  deleteRoute() {
    if (this.loaded_route_data_index !== -1) {
      deleteRouteOnServer(this.route_list[this.loaded_route_data_index].id);
      this.route_list.splice(this.loaded_route_data_index, 1);
      this.loaded_route_data_index = -1;
    }
    this.clearRouteOnMap();
    this.route_editing = false;
    this.route_loaded = false;
  }
}
</script>
<style lang="sass" scoped>
#flightPlannerMapDiv
  height: 90vh

#buttonsDiv
  ul
    margin-top: 10px
    margin-bottom: 10px
    list-style-type: none
  li
    margin-bottom: 10px

</style>
